# askquery.py
import sys
import getopt
import traceback

#sys.path.insert(1, "/applis/toolselan/bibl/python/")
sys.path.insert(1, "/Users/cp/devlopt/elan-data-analysis/bibl/python/")

import utils as utils
import pandas as pd

def init_askquery(filename):

    bloc1_columntypes = {
        'Annotation1': str,
        'AnnotationBeginTime1':int,
        'AnnotationEndTime1': int,
        'AnnotationDuration1': int,
        'TierName1': str,
        'TierType1': str,
        'TierParticipant1': str,
    }

    bloc2_columntypes = {
        'Annotation2': str,
        'AnnotationBeginTime2':int,
        'AnnotationEndTime2': int,
        'AnnotationDuration2': int,
        'TierName2': str,
        'TierType2': str,
        'TierParticipant2': str,
    }

    bloc3_columntypes = {
        'Annotation3': str,
        'AnnotationBeginTime3':int,
        'AnnotationEndTime3': int,
        'AnnotationDuration3': int,
        'TierName3': str,
        'TierType3': str,
        'TierParticipant3': str,
    }

    bloc4_columntypes = {
        'Annotation4': str,
        'AnnotationBeginTime4':int,
        'AnnotationEndTime4': int,
        'AnnotationDuration4': int,
        'TierName4': str,
        'TierType4': str,
        'TierParticipant4': str,
    }

    blocend_columntypes = {
        'IntersectionBegin': int,
        'IntersectionEnd': int,
        'IntersectionDuration': int,
        'TranscriptionName': str
    }

    data_frame = pd.read_csv(filename)
    #print(data_frame.head())
    width = data_frame.shape[1]
    if width == 11:
        new_df = bloc1_columntypes
        new_df.update(blocend_columntypes)
    elif width == 18:
        new_df = bloc1_columntypes
        new_df.update(bloc2_columntypes)
        new_df.update(blocend_columntypes)
    elif width == 25:
        new_df = bloc1_columntypes
        new_df.update(bloc2_columntypes)
        new_df.update(bloc3_columntypes)
        new_df.update(blocend_columntypes)
    elif width == 32:
        new_df = bloc1_columntypes
        new_df.update(bloc2_columntypes)
        new_df.update(bloc3_columntypes)
        new_df.update(bloc4_columntypes)
        new_df.update(blocend_columntypes)
    else:
        print("Unimplemented number of columns: " + str(width))
        exit(1)

    return (data_frame, new_df)

def comparaison_participant_value(part, value):
    if value == "1-M" and part == "mère": return True
    if value == "1-P" and part == "père": return True
    if value == "1-Ea" and part == "aîné": return True
    if value == "1-Eb" and part == "deuxième": return True
    if value == "1-Ec" and part == "troisième": return True
    return False

#2a. … quand X LNG (aud et/ou vis) à Y, est-ce que Y regarde X ?
def value2_is_participant1(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        # if comparaison_participant_value(old_row['TierParticipant1'], old_row['Annotation2']) == true:
        if ((old_row['Annotation2'] == "1-M" and old_row['TierParticipant1'] == "mère") or
            (old_row['Annotation2'] == "1-P" and old_row['TierParticipant1'] == "père") or
            (old_row['Annotation2'] == "1-Ea" and old_row['TierParticipant1'] == "aîné") or
            (old_row['Annotation2'] == "1-Eb" and old_row['TierParticipant1'] == "deuxième") or
            (old_row['Annotation2'] == "1-Ec" and old_row['TierParticipant1'] == "troisième")
        ):
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("Annotation2 is matched with participant1")
    print(ndf)
    return new_df_val

#2b. … quand X LNG (aud et/ou vis) à Y, est-ce que X regarde Y ET Y regarde X ?
def value3_is_participant1and2_and_reverse(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if (
                (old_row['TierParticipant1'] == old_row['TierParticipant2']) and
                (comparaison_participant_value(old_row['TierParticipant2'], old_row['Annotation3']) is True) and
                (old_row['Annotation1'] == old_row['Annotation2']) and
                (comparaison_participant_value(old_row['TierParticipant3'], old_row['Annotation2']) is True)
            ):
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("Annotation1 and value2 are matched with participant3 and participant1 and 2 are matched with value3")
    print(ndf)
    return new_df_val

def value3_is_participant1or2(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if ((old_row['Annotation3'] == "1-M" and (old_row['TierParticipant1'] == "mère" or old_row['TierParticipant2'] == "mère")) or
            (old_row['Annotation3'] == "1-P" and (old_row['TierParticipant1'] == "père" or old_row['TierParticipant2'] == "père")) or
            (old_row['Annotation3'] == "1-Ea" and (old_row['TierParticipant1'] == "aîné" or old_row['TierParticipant2'] == "aîné")) or
            (old_row['Annotation3'] == "1-Eb" and (old_row['TierParticipant1'] == "deuxième" or old_row['TierParticipant2'] == "deuxième")) or
            (old_row['Annotation3'] == "1-Ec" and (old_row['TierParticipant1'] == "troisième" or old_row['TierParticipant2'] == "troisième"))
        ):
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("Annotation1 is matched with participant2")
    print(ndf)
    return new_df_val

def participant1_is_participant2(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if old_row['TierParticipant1'] == old_row['TierParticipant2']:
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 is matched with participant2")
    print(ndf)
    return new_df_val

def participant1_is_participant3(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if old_row['TierParticipant1'] == old_row['TierParticipant3']:
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 is matched with participant3")
    print(ndf)
    return new_df_val

def replace_fusion12(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = dict(odf.iloc[index])
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if old_row['TierParticipant1'] == old_row['TierParticipant2']:
            if old_row['Annotation1'] == old_row['Annotation2']:
                old_row['TierParticipant2'] = old_row['Annotation1']
            elif old_row['Annotation1'] == "--":
                old_row['TierParticipant2'] = old_row['Annotation2']
            elif old_row['Annotation2'] == "--":
                old_row['TierParticipant2'] = old_row['Annotation1']
            else:
                old_row['TierParticipant2'] = 'autre'
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 is matched with participant2")
    print(ndf)
    return new_df_val

def replace_fusion34(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = dict(odf.iloc[index])
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if old_row['TierParticipant3'] == old_row['TierParticipant4']:
            if old_row['Annotation3'] == old_row['Annotation4']:
                old_row['TierParticipant4'] = old_row['Annotation3']
            elif old_row['Annotation3'] == "--":
                old_row['TierParticipant4'] = old_row['Annotation4']
            elif old_row['Annotation4'] == "--":
                old_row['TierParticipant4'] = old_row['Annotation3']
            else:
                old_row['TierParticipant4'] = 'autre'
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant3 is matched with participant4")
    print(ndf)
    return new_df_val

def participant1or2_is_participant3(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if (old_row['TierParticipant1'] == old_row['TierParticipant3']) or (old_row['TierParticipant2'] == old_row['TierParticipant3']):
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 or 2 is matched with participant3")
    print(ndf)
    return new_df_val

#3a. … quand X LNG (aud et/ou vis) à Y (Y=non-Z) ET Z ne LNG pas, est-ce que Z regarde X ?
#à mettre en regard avec total de X parle à Y (Y=non-Z)
# LNG part1 = X value1 = Y LNG part2 = Z value2 "--" ?? REG part3 = Z value3 = X ??
def langage_non_adresse_enfant_regarde_speaker_123(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
        if (
                    (old_row['TierParticipant1'] != '--')
                and (old_row['Annotation1'] != '--')
                and (old_row['Annotation1'] != '0-self')
                and (old_row['TierParticipant2'] != old_row['TierParticipant1'])
                and (old_row['TierParticipant2'] != '--')
                and (old_row['Annotation2'] == '--')
                and (comparaison_participant_value(old_row['TierParticipant2'], old_row['Annotation1']) is False)
                and (old_row['TierParticipant2'] == old_row['TierParticipant3'])
                and (old_row['Annotation3'] != '0-self')
        ):
            if comparaison_participant_value(old_row['TierParticipant1'], old_row['Annotation3']) is True:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'regarde_speaker_qui_ne_lui_parle_pas'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'regarde_speaker_qui_ne_lui_parle_pas'
            else:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'neregardepas_speaker_qui_ne_lui_parle_pas'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'neregardepas_speaker_qui_ne_lui_parle_pas'
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("lnae regarde speaker")
    print(ndf)
    return new_df_val

#4a. … quand X LNG (aud et/ou vis) à Y (Y=non-Z) ET Z ne LNG pas, est-ce que Z regarde Y ?
#  - à mettre en regard avec total de X parle à Z
# LNG part1 = X value1 = Y LNG part2 = Z value2 "--" ?? REG part3 = Z value3 = Y ??
def langage_non_adresse_enfant_regarde_adressee_123(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
        if (
                (old_row['TierParticipant1'] != '--')
            and (old_row['Annotation1'] != '--')
            and (old_row['Annotation1'] != '0-self')
            and (old_row['TierParticipant2'] != old_row['TierParticipant1'])
            and (old_row['TierParticipant2'] != '--')
            and (old_row['Annotation2'] == '--')
            and (comparaison_participant_value(old_row['TierParticipant2'], old_row['Annotation1']) is False)
            and (old_row['TierParticipant2'] == old_row['TierParticipant3'])
            and (old_row['Annotation3'] != '0-self')
        ):
            if old_row['Annotation3'] == old_row['Annotation1']:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'regarde_adressee'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'regarde_adressee'
            else:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'neregardepas_adressee'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'neregardepas_adressee'
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("lnae regarde adressee")
    print(ndf)
    return new_df_val

#3b. … quand X LNG (aud et/ou vis) à Z ET Z ne LNG pas, est-ce que Z regarde X ?
#à mettre en regard avec total de X parle à Z
# LNG part1 = X value1 = Z LNG part2 = Z value2 "--" ?? REG part3 = Z value3 = X ??
def langage_sans_reponse_enfant_123(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
        if (
                (old_row['TierParticipant1'] != '--')
                and (old_row['Annotation1'] != '--')
                and (old_row['Annotation1'] != '0-self')
                and (old_row['TierParticipant2'] != old_row['TierParticipant1'])
                and (old_row['TierParticipant2'] != '--')
                and (old_row['Annotation2'] == '--')
                and (comparaison_participant_value(old_row['TierParticipant2'], old_row['Annotation1']) is True)
                and (old_row['TierParticipant2'] == old_row['TierParticipant3'])
                and (old_row['Annotation3'] != '0-self')
        ):
            if comparaison_participant_value(old_row['TierParticipant1'], old_row['Annotation3']) is True:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'regarde_speaker_qui_lui_parle'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'regarde_speaker_qui_lui_parle'
            else:
                # old_row_list = list(old_row)
                # old_row_list['TierParticipant3'] = 'neregardepas_speaker_qui_lui_parle'
                # old_row = tuple(old_row_list)
                old_row['TierParticipant3'] = 'neregardepas_speaker_qui_lui_parle'
            newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 is matched with participant2")
    print(ndf)
    return new_df_val

def same_participant(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
        part = old_row['TierParticipant1']
        if 'TierParticipant2' in old_row and old_row['TierParticipant2'] != part:
            continue
        if 'TierParticipant3' in old_row and old_row['TierParticipant3'] != part:
            continue
        if 'TierParticipant4' in old_row and old_row['TierParticipant4'] != part:
            continue
        if 'TierParticipant5' in old_row and old_row['TierParticipant5'] != part:
            continue
        newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("all the participants are the same")
    print(ndf)
    return new_df_val

def notiret(odf, ndf):
    nbrow = len(odf)
    newdata = list()
    for index in range(0, nbrow):
        old_row = odf.iloc[index]
    #    print(old_row['Annotation1'] + ' ' + old_row['TierParticipant2'])
        if old_row['Annotation1'] == '--':
            continue
        if 'Annotation2' in old_row and old_row['Annotation2'] == '--':
            continue
        if 'Annotation3' in old_row and old_row['Annotation3'] == '--':
            continue
        if 'Annotation4' in old_row and old_row['Annotation4'] == '--':
            continue
        if 'Annotation5' in old_row and old_row['Annotation5'] == '--':
            continue
        newdata.append(old_row)
    new_df_val = pd.DataFrame(newdata, columns=ndf.keys())
    print("participant1 is matched with participant2")
    print(ndf)
    return new_df_val

action_list = ["annot2ispart1", "annot3ispart1or2", "annot3ispart1and2andreverse", "part1ispart2", "part1ispart3", "part1or2ispart3", "notiret",
               "lnaera123", "lnaers123", "lsre123", "samepart", "fusion12", "fusion34"]

def printhelp():
    print('askquery.py <inputfiles ...> -o <outputfile> -a <action> -f <format>')
    print('   inputfiles = listes des fichiers a traiter')
    print('   -o outfile = fichier resultat au format csv')
    print('   -a action = filter action to be executed in: ' + ' '.join(action_list))
    print('   -f format = file output format: CSV or XLSX')

def printnotice():
    print('askquery.py <inputfiles ...> -o <outputfile> -a <action> -f <format>')
    print('askquery.py -h ; for help')

def askquery(argv):
    outputfile = ''
    action = ''
    format = ""
    try:
        opts, args = getopt.gnu_getopt(argv,"a:o:f:h",["action=", "ofile=", "format=", "help"])
    except getopt.GetoptError:
        printnotice()
        sys.exit(3)
    for opt, arg in opts:
        if opt in ("-h", "--help"):
            printhelp()
            sys.exit(2)
        elif opt in ("-a", "--action"):
            if action != '':
                print('only one action per command')
                sys.exit(2)
            if (arg not in action_list):
                print('Error: the action ' + arg + ' has to be in that list: ' + str(action_list))
                sys.exit(2)
            action = arg
        elif opt in ("-f", "--format"):
            format = arg.lower()
            if (format != "csv" and format != "xlsx"):
                print('Erreur: le format doit être CSV ou XLSX, pas ' + arg)
                sys.exit(2)
        elif opt in ("-o", "--ofile"):
            outputfile = arg
    if outputfile == '':
        print('Give an name for the output')
        sys.exit(1)
    format = utils.processargs(args, outputfile, format, printnotice)
    for inputfile in args:
        try:
            print('Loading: ' + inputfile)
            (odf, ndf) = init_askquery(inputfile)
            # print(odf)
            # print(ndf)
            if action == "annot2ispart1":
                newdf =value2_is_participant1(odf, ndf)
            elif action == "part1ispart2":
                newdf =participant1_is_participant2(odf, ndf)
            elif action == "part1ispart3":
                newdf =participant1_is_participant3(odf, ndf)
            elif action == "samepart":
                newdf =same_participant(odf, ndf)
            elif action == "part1or2ispart3":
                newdf =participant1or2_is_participant3(odf, ndf)
            elif action == "annot3ispart1or2":
                newdf =value3_is_participant1or2(odf, ndf)
            elif action == "annot3ispart1and2andreverse":
                newdf =value3_is_participant1and2_and_reverse(odf, ndf)
            elif action == "notiret":
                newdf =notiret(odf, ndf)
            elif action == "lnaera123":
                newdf =langage_non_adresse_enfant_regarde_adressee_123(odf, ndf)
            elif action == "lnaers123":
                newdf =langage_non_adresse_enfant_regarde_speaker_123(odf, ndf)
            elif action == "lsre123":
                newdf =langage_sans_reponse_enfant_123(odf, ndf)
            elif action == "fusion12":
                newdf =replace_fusion12(odf, ndf)
            elif action == "fusion34":
                newdf =replace_fusion34(odf, ndf)
            else:
                print("unknown action: " + action)
        except KeyError:
            # exc = sys.exception()
            # print("*** print_tb:")
            # traceback.print_tb(exc.__traceback__, limit=1, file=sys.stdout)
            # print("*** print_exception:")
            # traceback.print_exception(exc, limit=2, file=sys.stdout)
            # print("*** print_exc:")
            traceback.print_exc() # (limit=2, file=sys.stdout)
            print('Probably bad format for input file: ' + inputfile)
            pass
        except KeyboardInterrupt:
            sys.exit(1)
        except Exception as e:
            print('Probably bad input file or general error?')
            print(e)
            traceback.print_exc()
            sys.exit(6)

        if (format == "xlsx"):
            newdf.to_excel(outputfile, header=True, index=None)
        else:
            newdf.to_csv(outputfile, index=False)

    sys.exit(0)

if __name__ == "__main__":
   askquery(sys.argv[1:])
